(****************************************)
(* ITA Office97 Style Components        *)
(* Version 1.5                          *)
(*                                      *)
(****************************************)
(* (c) 1996-98 ITA Software Labs        *)
(* All right reserved.                  *)
(*                                      *)
(****************************************)
(* Internet: aepp@vsgtu.eastsib.ru      *)
(* WWW:                                 *)
(*   http://www.ita.eastsib.ru          *)
(*   http://i-connect.ru/~ita           *)                  
(****************************************)
unit odmfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ita_common, ExtCtrls, ComCtrls;

type
  TODMenuForm = class(TForm)
    itaSavePos1: TitaSavePos;
    itaMenu: TitaMenu;
    Rectangle1: TMenuItem;
    Colors1: TMenuItem;
    rect11: TMenuItem;
    rect21: TMenuItem;
    rect31: TMenuItem;
    rect41: TMenuItem;
    rect51: TMenuItem;
    color11: TMenuItem;
    color12: TMenuItem;
    color13: TMenuItem;
    color14: TMenuItem;
    color15: TMenuItem;
    color16: TMenuItem;
    color17: TMenuItem;
    Colums1: TMenuItem;
    col11: TMenuItem;
    col21: TMenuItem;
    col12: TMenuItem;
    col13: TMenuItem;
    col22: TMenuItem;
    col23: TMenuItem;
    col24: TMenuItem;
    col25: TMenuItem;
    col31: TMenuItem;
    col32: TMenuItem;
    col33: TMenuItem;
    col34: TMenuItem;
    itaPanel: TitaPanel;
    StatusBar: TStatusBar;
    itaShape: TitaShape;
    itaPopupMenu: TitaPopupMenu;
    itaPanel1: TitaPanel;
    itaPanel2: TitaPanel;
    Rectangle2: TMenuItem;
    Colors2: TMenuItem;
    Columns1: TMenuItem;
    Rect12: TMenuItem;
    rect13: TMenuItem;
    rect14: TMenuItem;
    rect15: TMenuItem;
    rect16: TMenuItem;
    color18: TMenuItem;
    color19: TMenuItem;
    color110: TMenuItem;
    color111: TMenuItem;
    color112: TMenuItem;
    color113: TMenuItem;
    color114: TMenuItem;
    col14: TMenuItem;
    col15: TMenuItem;
    col16: TMenuItem;
    col17: TMenuItem;
    col26: TMenuItem;
    col27: TMenuItem;
    col28: TMenuItem;
    col29: TMenuItem;
    col35: TMenuItem;
    col36: TMenuItem;
    col37: TMenuItem;
    col38: TMenuItem;
    itaPanel3: TitaPanel;
    procedure itaMenuMeasureItem(MenuItem: TMenuItem; var Width,
      Height: Integer; Canvas: TCanvas);
    procedure itaMenuDrawItem(MenuItem: TMenuItem; Canvas: TCanvas;
      ItemState: Integer; ItemRect: TRect);
    procedure rect51Click(Sender: TObject);
    procedure color17Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    procedure DoHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  ODMenuForm: TODMenuForm;

implementation {=======================================================}

{$R *.DFM}

const
  IBrush: array [1..5] of TBrushStyle = (bsSolid, bsBDiagonal,
    bsFDiagonal, bsCross, bsDiagCross);
  IColor: array [1..7] of TColor = (clGreen, clRed, clBlue,
    clYellow, clWhite, clBlack, clFuchsia);

var
  OldOnHint: TNotifyEvent;

procedure TODMenuForm.DoHint(Sender: TObject);
begin
  StatusBar.Panels[0].Text := Application.Hint;
end;

procedure TODMenuForm.itaMenuMeasureItem(MenuItem: TMenuItem; var Width,
  Height: Integer; Canvas: TCanvas);
begin
  case MenuItem.Tag of
    1: begin
         Width := 100;
         Height := 40;
       end;
    2: begin
         Width := 80;
         Height := 26;
       end;
    3: begin
         Width := 40;
         Height := 40;
       end;
    4: begin
         Width := 90;
         Height := 22;
       end;
  end;
end;

procedure TODMenuForm.itaMenuDrawItem(MenuItem: TMenuItem; Canvas: TCanvas;
  ItemState: Integer; ItemRect: TRect);
begin
  InflateRect(ItemRect, -2, -2);
  case MenuItem.Tag of
    1: with Canvas do
       begin
         If ItemState and msSelected <> 0 Then
         begin
           Brush.Color := clHighlight;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end
         else
         begin
           Brush.Color := clBtnFace;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         Brush.Color := clBtnHighlight;
         Brush.Style := IBrush[MenuItem.GroupIndex];
         Pen.Style := psSolid;
         Pen.Color := clBtnShadow;
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
       end;
    2: with Canvas do
       begin
         If ItemState and msSelected <> 0 Then
         begin
           Brush.Color := clHighlight;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end
         else
         begin
           Brush.Color := clBtnFace;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         Brush.Color := IColor[MenuItem.GroupIndex];
         Pen.Style := psSolid;
         Pen.Color := clBtnShadow;
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           RoundRect(Left, Top, Right, Bottom, 7, 7);
       end;
    3: with Canvas do
       begin
         If ItemState and msSelected <> 0 Then
         begin
           Brush.Color := clHighlight;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end
         else
         begin
           Brush.Color := clBtnFace;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         Brush.Color := IColor[MenuItem.GroupIndex];
         Pen.Style := psSolid;
         Pen.Color := clBtnShadow;
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           RoundRect(Left, Top, Right, Bottom, 8, 8);
       end;
    4: with Canvas do
       begin
         Pen.Style := psClear;
         If ItemState and msSelected <> 0 Then
           Brush.Color := clHighlight
         else
           Brush.Color := clBtnFace;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           TextOut(Left+4, (Top+Bottom) div 2 -
             TextHeight(MenuItem.Caption) div 2, MenuItem.Caption);
       end;
  end;
end;

procedure TODMenuForm.rect51Click(Sender: TObject);
begin
  itaShape.Brush.Style := IBrush[(Sender as TMenuItem).GroupIndex];
end;

procedure TODMenuForm.color17Click(Sender: TObject);
begin
  itaShape.Brush.Color := IColor[(Sender as TMenuItem).GroupIndex];
end;

procedure TODMenuForm.FormActivate(Sender: TObject);
begin
  OldOnHint := Application.OnHint;
  Application.OnHint := DoHint;
end;

procedure TODMenuForm.FormDeactivate(Sender: TObject);
begin
  Application.OnHint := OldOnHint;
end;


end.
